Ruby - Bug #15832

IPAddr.new accepts invalid mask IP address
05/05/2019 08:52 PM - tsuna (Kenta Tsuna)

Status: Closed

Priority: Normal

Assignee: knu (Akinori MUSHA)

Target version:

ruby -v: ruby 2.7.0dev (2019-05-05 trunk Backport: 2.4: UNKNOWN, 2.5: UNKNOWN, 2.6:
594a033ff0) [x86_64-linux] UNKNOWN

Description

IPAddr.new accepts IP address with multiple mask and/or zero padded one.

$ cat ipaddr.rb
require 'ipaddr'

addrs = %w[192.0.2.0/24/16
192.0.2.0/00024
192.0.2.0/24/00016
192.0.2.0/00024/16

2001:db8::/32/24
2001:db8::/00032
2001:db8::/32/00024
2001:db8::/00032/24]

addrs.each do |addr|
begin
p IPAddr.new (addr)
puts "#{addr} is valid"
rescue StandardError
puts "#{addr} is invalid"
end
end

$ ruby ipaddr.rb

#<IPAddr: IPv4:192.0.2.0/255.255.255.0>

192.0.2.0/24/16 is wvalid

#<IPAddr: IPv4:192.0.2.0/255.255.255.0>

192.0.2.0/00024 is valid

#<IPAddr: IPv4:192.0.2.0/255.255.255.0>

192.0.2.0/24/00016 is valid

#<IPAddr: IPv4:192.0.2.0/255.255.255.0>

192.0.2.0/00024/16 is valid

#<IPAddr: IPv6:2001:0db8:0000:0000:0000:0000:0000:0000/ffff:££££:0000:0000:0000:0000:0000:0000>
2001:db8::/32/24 is valid

#<IPAddr: IPv6:2001:0db8:0000:0000:0000:0000:0000:0000/£ffff:£f£f£f£:0000:0000:0000:0000:0000:0000>
2001:db8::/00032 is valid

#<IPAddr: IPv6:2001:0db8:0000:0000:0000:0000:0000:0000/£ffff:£f£f£f£:0000:0000:0000:0000:0000:0000>
2001:db8::/32/00024 is valid

#<IPAddr: IPv6:2001:0db8:0000:0000:0000:0000:0000:0000/£ffff:£f£f£f£:0000:0000:0000:0000:0000:0000>
2001:db8::/00032/24 is valid

History

#1 - 06/05/2019 02:02 AM - jeremyevans0 (Jeremy Evans)
- Status changed from Open to Assigned

- Assignee set to knu (Akinori MUSHA)

| submitted a pull request to ruby/ipaddr to fix this: https:/github.com/ruby/ipaddr/pull/17

#2 - 07/09/2019 06:55 AM - ioquatix (Samuel Williams)
https://github.com/ruby/ipaddr/pull/17

- Status changed from Assigned to Closed

| merged it.
